#include<iostream>
#include<set>
#include<string>
#define endl '\n'
using namespace std;
const long long mod=1000000009;
const long long base=31;
long long h,st[100005],p[100005],begi=1,m[100005];
set <string> u;
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    st[0]=1;
    for(int i=1;i<=100000;i++)
    {
        st[i]=(st[i-1]*base)%mod;
    }
    string s;
    cin>>s;

    string a;
    long long n;
    cin>>n;

    for(int i=1;i<=n;i++)
    {
        cin>>a;
        u.insert(a);
    }
    for(int i=0;i<s.size();i++)
    {
       for(int j=s.size()-1;j>=i;j--)
       {
           if(u.count(s.substr(i,j-i)))
           {
               m[i]++;
               m[j]--;
               break;
           }
       }
    }
    long long t=0;
    for(int i=0;i<s.size();i++)
    {
        t+=m[i];
        if(t==0) cout<<s[i];
    }
    cout<<endl;
}
